/*
**==============================================================================
**
** Open Management Infrastructure (OMI)
**
** Copyright (c) Microsoft Corporation
** 
** Licensed under the Apache License, Version 2.0 (the "License"); you may not 
** use this file except in compliance with the License. You may obtain a copy 
** of the License at 
**
**     http://www.apache.org/licenses/LICENSE-2.0 
**
** THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
** KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED 
** WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, 
** MERCHANTABLITY OR NON-INFRINGEMENT. 
**
** See the Apache 2 License for the specific language governing permissions 
** and limitations under the License.
**
**==============================================================================
*/

#ifndef _omi_logbase_h
#define _omi_logbase_h

#if defined(__cplusplus)
extern "C" {
#endif

/* Log levels (default level is OMI_WARNING */
typedef enum _Log_Level
{
    OMI_FATAL,
    OMI_ERROR,
    OMI_WARNING,
    OMI_INFO,
    OMI_DEBUG,
    OMI_VERBOSE
}
Log_Level;

/* Get the current log level */
Log_Level Log_GetLevel();

#if defined(__cplusplus)
}
#endif

#endif /* _omi_logbase_h */
