/*
**==============================================================================
**
** Open Management Infrastructure (OMI)
**
** Copyright (c) Microsoft Corporation
** 
** Licensed under the Apache License, Version 2.0 (the "License"); you may not 
** use this file except in compliance with the License. You may obtain a copy 
** of the License at 
**
**     http://www.apache.org/licenses/LICENSE-2.0 
**
** THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
** KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED 
** WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, 
** MERCHANTABLITY OR NON-INFRINGEMENT. 
**
** See the Apache 2 License for the specific language governing permissions 
** and limitations under the License.
**
**==============================================================================
*/


# line 2 "mof.y"

#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "buffer.h"
#include "types.h"
#include "state.h"
#include "ptrarray.h"

#define ARRAYOF(TYPE) ((MI_Uint32)TYPE | (MI_Uint32)MI_ARRAY_BIT)

extern int yylex();
extern int openIncludeFile(const char* path);


# line 20 "mof.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{
    MI_Boolean boolean;
    MI_Sint64 integer;
    MI_Real64 real;
    MI_Char16 character;
    char* string;
    char* identifier;
    char* dollarIdentifier;
    MI_Type type;
    MI_PropertyDecl* property;
    MI_MethodDecl* methodDecl;
    MI_ParameterDecl* parameter;
    MOF_ParameterList parameterList;
    MOF_FeatureList featureList;
    MI_QualifierDecl* qualifierDeclaration;
    MOF_ConstantValue constantValue;
    MOF_Initializer initializer;
    MI_Uint32 flags;
    MI_Qualifier* qualifier;
    MOF_QualifierList qualifierList;
    MI_ClassDecl* classDeclaration;
    MI_InstanceDecl* instanceDeclaration;
} YYSTYPE;
# define TOK_ERROR 257
# define TOK_BOOLEAN 258
# define TOK_SINT8 259
# define TOK_UINT8 260
# define TOK_SINT16 261
# define TOK_UINT16 262
# define TOK_SINT32 263
# define TOK_UINT32 264
# define TOK_SINT64 265
# define TOK_UINT64 266
# define TOK_REAL32 267
# define TOK_REAL64 268
# define TOK_DATETIME 269
# define TOK_CHAR16 270
# define TOK_STRING 271
# define TOK_OBJECT 272
# define TOK_BOOLEAN_VALUE 273
# define TOK_REF 274
# define TOK_SCOPE 275
# define TOK_CLASS 276
# define TOK_ASSOCIATION 277
# define TOK_INDICATION 278
# define TOK_QUALIFIER 279
# define TOK_PROPERTY 280
# define TOK_REFERENCE 281
# define TOK_METHOD 282
# define TOK_PARAMETER 283
# define TOK_ANY 284
# define TOK_FLAVOR 285
# define TOK_ENABLEOVERRIDE 286
# define TOK_DISABLEOVERRIDE 287
# define TOK_RESTRICTED 288
# define TOK_TOSUBCLASS 289
# define TOK_TOINSTANCE 290
# define TOK_TRANSLATABLE 291
# define TOK_INSTANCE 292
# define TOK_OF 293
# define TOK_AS 294
# define TOK_PRAGMA 295
# define TOK_SCHEMA 296
# define TOK_INTEGER_VALUE 297
# define TOK_REAL_VALUE 298
# define TOK_STRING_VALUE 299
# define TOK_CHAR_VALUE 300
# define TOK_IDENT 301
# define TOK_ALIAS_IDENTIFIER 302
# define TOK_NULL 303

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#define	YYCONST	const
#else
#include <malloc.h>
#include <memory.h>
#define	YYCONST
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef yyerror
#if defined(__cplusplus)
	void yyerror(YYCONST char *);
#endif
#endif
#ifndef yylex
	int yylex(void);
#endif
	int yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256
static YYCONST yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 70,
	274, 157,
	-2, 66,
-1, 82,
	274, 158,
	-2, 78,
-1, 83,
	274, 159,
	-2, 79,
	};
# define YYNPROD 161
# define YYLAST 847
static YYCONST yytabelem yyact[]={

    13,   149,    15,   119,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    82,    81,    83,   129,    58,
    96,   209,    18,    21,    22,    25,    24,    23,    46,    37,
    20,    29,   184,   118,   121,    26,    27,    28,   245,    19,
   177,    33,   140,   133,    13,   179,    34,    17,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    82,
    81,    83,    35,   145,    86,   274,    18,    21,    22,    25,
    24,    23,    96,    43,    20,    29,    30,   193,    61,    26,
    27,    28,   194,    19,   252,    33,   218,    31,    13,    32,
    44,    17,   195,   228,    18,    21,    22,    25,    24,    23,
    54,   113,    20,    29,   146,   100,   231,    26,    27,    28,
   113,    19,   165,    33,   154,    51,   143,   187,    53,    17,
   169,   246,   241,   247,   242,   109,   110,    58,   111,    44,
   168,   114,    13,   141,   109,   110,    58,   111,    44,    13,
   114,   102,   103,   104,   105,   106,   107,   219,   220,   221,
   182,   222,   223,   224,   225,   226,   213,    94,   214,    95,
    89,   285,   284,   143,    50,   251,    63,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    82,    81,
    83,    69,    13,    56,   283,    18,    21,    22,    25,    24,
    23,    97,   280,    20,    29,   153,   276,   273,    26,    27,
    28,   190,    19,   191,    33,   150,   271,   203,   269,   205,
    17,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    82,    81,    83,    69,   211,   123,   227,    18,
    21,    22,    25,    24,    23,    13,   183,    20,    29,   143,
   262,   261,    26,    27,    28,   135,    19,   136,    33,   259,
   186,   254,   249,   144,    17,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    82,    81,    83,   288,
    13,   236,    65,    18,    21,    22,    25,    24,    23,    13,
   244,    20,    29,   212,   233,   229,    26,    27,    28,   208,
    19,   119,    33,   176,   175,   155,   126,    99,    17,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    82,    81,    83,   185,   206,    13,    64,    18,    21,    22,
    25,    24,    23,   163,     9,    20,    29,    11,   263,   139,
    26,    27,    28,   125,    19,    62,    33,    48,   286,   152,
    12,   112,    17,     8,   137,   279,    56,   216,   181,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    82,    81,    83,   178,    41,   275,   170,    18,    21,    22,
    25,    24,    23,     4,   113,    20,    29,   124,   170,   101,
    26,    27,    28,    57,    19,   278,    33,   170,   277,    55,
   202,   186,    17,   169,    42,   171,   122,   173,   109,   110,
    58,   111,    30,   168,   114,     7,     5,   270,    39,   199,
   235,   201,   116,    31,   257,    32,   142,   258,    52,    38,
    18,    21,    22,    25,    24,    23,   138,   143,    20,    29,
     2,   197,    14,    26,    27,    28,     3,    19,   255,    33,
    85,   143,    88,   217,   234,    17,    30,   235,   115,   148,
    10,    10,   210,   166,   120,     9,    47,    31,    11,    32,
    98,     6,    60,     1,    18,    21,    22,    25,    24,    23,
     0,    12,    20,    29,     8,     0,    68,    26,    27,    28,
   151,    19,    30,    33,     0,   164,     0,     0,     0,    17,
     0,     0,    68,    31,    67,    32,   113,     0,     0,   130,
    18,    21,    22,    25,    24,    23,     0,     0,    20,    29,
    67,     0,     0,    26,    27,    28,   113,    19,     0,    33,
   109,   110,    58,   111,   167,    17,   114,   196,   113,   174,
   151,     0,     0,     0,     0,   169,     0,   113,     0,     0,
   109,   110,    58,   111,   157,   168,   114,   169,     0,   172,
     0,     0,   109,   110,    58,   111,   169,   168,   114,    84,
   113,   109,   110,    58,   111,     0,   168,   114,     0,    16,
     0,    36,    66,    40,     0,     0,    90,   200,   204,   108,
   159,   117,     0,     0,   109,   110,    58,   111,    66,     0,
   114,     0,     0,     0,    45,   128,   256,    49,     0,   156,
     0,   158,     0,    59,     0,     0,    87,     0,     0,   198,
     0,    40,    91,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    92,    81,    93,   127,     0,   131,   132,
   240,   143,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   192,     0,   134,     0,   207,     0,
     0,     0,   198,     0,   264,   265,   147,   287,     0,   215,
     0,     0,     0,     0,     0,     0,   180,     0,     0,     0,
     0,     0,     0,   230,     0,     0,     0,   232,     0,   189,
     0,     0,     0,   281,   282,   198,     0,   243,   160,   161,
   162,   248,     0,     0,     0,     0,     0,     0,     0,     0,
   253,     0,     0,     0,     0,   147,     0,   180,   188,     0,
     0,     0,     0,     0,     0,     0,     0,   260,     0,     0,
     0,     0,     0,     0,     0,     0,   239,     0,   268,     0,
     0,     0,     0,   272,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   237,   238,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   250,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   266,
   267,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   147,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   147 };
static YYCONST yytabelem yypact[]={

   179,    48,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -299,  -182,
  -230,  -182,  -264,  -182,-10000000,   324,    15,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -182,  -265,   279,  -182,    71,-10000000,
    60,  -280,-10000000,  -182,   -47,     6,  -182,   116,   354,  -103,
-10000000,  -182,   239,  -145,  -163,-10000000,   287,    -8,-10000000,   -33,
   -91,   237,-10000000,-10000000,-10000000,-10000000,  -182,  -254,  -182,  -182,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -231,-10000000,  -182,  -103,   285,  -233,
    72,-10000000,-10000000,-10000000,-10000000,   -51,   224,  -301,-10000000,  -145,
  -145,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   298,-10000000,
-10000000,-10000000,  -296,-10000000,-10000000,    70,-10000000,-10000000,-10000000,-10000000,
-10000000,   236,-10000000,-10000000,-10000000,-10000000,-10000000,   540,  -182,  -182,
  -182,   264,   336,-10000000,   -33,-10000000,   -51,-10000000,   234,  -245,
   323,   223,    89,   -61,-10000000,   188,-10000000,    56,  -182,-10000000,
  -145,-10000000,-10000000,-10000000,  -163,-10000000,-10000000,   142,   243,    41,
   350,   148,   255,-10000000,   230,-10000000,-10000000,-10000000,-10000000,  -272,
   101,-10000000,    97,   243,-10000000,-10000000,-10000000,   307,  -129,-10000000,
-10000000,-10000000,   223,     0,-10000000,   226,-10000000,   243,    45,-10000000,
-10000000,   243,   225,   403,   212,-10000000,  -182,  -182,  -210,-10000000,
    63,   243,    -3,-10000000,    62,   243,-10000000,   193,-10000000,  -182,
    40,-10000000,-10000000,-10000000,   243,   192,  -145,   373,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
   190,   243,   182,-10000000,   181,    91,-10000000,    25,    25,  -182,
  -182,-10000000,   243,   149,   366,   147,-10000000,   243,   138,-10000000,
   -58,-10000000,  -172,   137,-10000000,   344,-10000000,-10000000,  -129,-10000000,
   133,-10000000,-10000000,-10000000,-10000000,-10000000,    25,    25,   125,-10000000,
   103,-10000000,   102,-10000000,   224,-10000000,-10000000,  -145,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   144,-10000000,-10000000 };
static YYCONST yytabelem yypgo[]={

     0,   463,   341,   559,   431,   159,   524,   527,   335,    92,
    77,   316,   272,   166,   462,   394,   157,   461,   456,   416,
   485,   453,   452,   112,    45,   348,   448,    86,   443,   442,
   379,   438,   105,   426,   408,   419,   449,   418,   406,   405,
   104,    63,   430,   373 };
static YYCONST yytabelem yyr1[]={

     0,     1,     1,     1,    42,    42,    42,    42,    43,    38,
    38,    38,    38,    15,    15,    14,    14,    14,    14,    14,
    14,    14,    14,    36,    35,    35,    34,    34,    34,    34,
    37,    37,    31,    31,    32,    32,    30,    30,    30,    30,
    30,    30,     8,     8,     8,     8,     8,     8,     8,     8,
    12,    12,    12,    12,    12,    12,    12,    12,    11,    11,
    11,    11,    13,    13,    13,    13,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     4,    10,    10,     9,     9,     9,     9,     9,     9,     9,
     9,    19,    19,    20,    20,    21,    21,    22,    22,    23,
    23,    23,    24,    24,    25,    25,    26,    26,     6,     6,
     6,     6,     6,     6,     2,     2,    17,    17,    18,    18,
    18,    18,    29,    28,    28,    27,    27,    27,    27,    27,
    27,    27,    27,    33,    39,    39,    39,    39,    16,     5,
    41,    41,    40,    40,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3 };
static YYCONST yytabelem yyr2[]={

     0,     3,     5,     3,     3,     3,     3,     3,    11,     7,
    11,     9,    13,     9,     7,     3,     3,     3,     3,     5,
     5,     5,     5,     7,     3,     7,     3,     5,     7,     9,
     7,     3,     3,     7,     3,     5,     3,     3,     3,     3,
     3,     3,     7,     9,     9,    11,    11,    13,    13,    15,
     7,     9,     9,    11,    11,    13,    13,    15,     7,     9,
     9,    11,    13,    15,    11,    13,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     5,     3,     7,     5,     5,     7,     7,     7,     7,     9,
     9,     7,     5,     3,     3,     7,     5,     3,     7,     3,
     3,    13,     3,     3,     7,     5,     3,     7,     3,     3,
     3,     3,     3,     3,     3,     5,    11,    13,     5,     9,
     7,    11,    11,     3,     7,     3,     3,     3,     3,     3,
     3,     3,     3,    11,     9,    11,    11,    13,     9,     5,
     3,     5,     9,    11,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3 };
static YYCONST yytabelem yychk[]={

-10000000,    -1,   -42,   257,   -43,   -38,   -17,   -39,   295,   276,
   -36,   279,   292,    91,   -42,   301,    -3,   301,   276,   293,
   284,   277,   278,   281,   280,   279,   289,   290,   291,   285,
   258,   269,   271,   295,   276,   292,    -3,   293,   -35,   -34,
    -3,    40,   -15,    58,   123,    -3,   293,   -18,    58,    -3,
    93,    44,   -37,    58,    40,   -25,   123,    -2,   299,    -3,
   -14,   125,    -8,   -13,   -11,   -12,    -7,   -36,    -4,   272,
   258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
   268,   270,   269,   271,    -3,   -15,    58,    -3,   -29,    44,
    -7,   258,   269,   271,   -16,    -5,   123,   294,   -34,    58,
   -32,   -30,   286,   287,   288,   289,   290,   291,    -6,   297,
   298,   300,    -2,   273,   303,   -26,   125,    -6,    41,   299,
   -15,   125,    -8,   -13,   -11,   -12,    59,    -3,    -7,   272,
    -4,    -3,    -3,   274,    -3,   -16,    -5,    59,   -33,    44,
   275,    61,   -19,    91,   -16,   -41,   -40,    -3,   -36,   302,
   -32,   -30,    41,   125,    44,    59,    59,   -19,    61,    40,
    -3,    -3,    -3,    59,   -20,   -23,   -21,    -6,   302,   292,
   123,    59,   -19,    61,   -15,   -16,    59,   285,    40,   -24,
    -6,   -25,    61,   297,    93,   125,   -40,    61,    -3,    -6,
    59,    61,   -20,   -10,    41,    -9,    -7,    -4,   -36,    59,
   -19,    61,    40,    59,   -19,    61,    59,   -20,    59,   293,
   -22,   125,   -23,    59,    61,   -20,    40,   -28,   -27,   276,
   277,   278,   280,   281,   282,   283,   284,   -24,    93,    59,
   -20,    61,   -20,    59,    41,    44,    59,    -3,    -3,    -7,
    -4,    59,    61,   -20,   -10,    41,    59,    61,   -20,    59,
    -3,   125,    44,   -20,    59,   -31,   -30,    41,    44,    59,
   -20,    59,    59,    -9,   -19,   -19,    -3,    -3,   -20,    59,
    41,    59,   -20,    59,   123,   -23,    59,    44,    41,   -27,
    59,   -19,   -19,    59,    59,    59,   -41,   -30,   125 };
static YYCONST yytabelem yydef[]={

     0,    -2,     1,     3,     4,     5,     6,     7,     0,     0,
     0,     0,     0,     0,     2,     0,     0,   144,   145,   146,
   147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
   157,   158,   159,   160,     0,     0,     0,     0,     0,    24,
    26,     0,     9,     0,     0,     0,     0,     0,     0,     0,
    23,     0,    27,     0,     0,    31,     0,     0,   114,     0,
     0,     0,    15,    16,    17,    18,     0,     0,     0,     0,
    -2,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    -2,    -2,     0,    11,     0,     0,     0,     0,
   118,    66,    78,    79,   134,     0,     0,     0,    25,     0,
    28,    34,    36,    37,    38,    39,    40,    41,     0,   108,
   109,   110,   111,   112,   113,     0,   105,   106,     8,   115,
    10,     0,    19,    20,    21,    22,    14,     0,     0,     0,
     0,     0,     0,    80,     0,   135,     0,   116,     0,     0,
     0,     0,   120,     0,   136,     0,   140,     0,     0,   139,
    29,    35,    30,   104,     0,    13,    42,     0,     0,     0,
     0,     0,     0,    58,     0,    93,    94,    99,   100,     0,
     0,    50,     0,     0,    12,   137,   117,     0,     0,   119,
   102,   103,     0,     0,    92,     0,   141,     0,     0,   107,
    44,     0,     0,     0,     0,    81,     0,     0,     0,    43,
     0,     0,     0,    51,     0,     0,    59,     0,    60,     0,
     0,    96,    97,    52,     0,     0,     0,     0,   123,   125,
   126,   127,   128,   129,   130,   131,   132,   121,    91,   138,
     0,     0,     0,    46,     0,     0,    64,    83,    84,     0,
     0,    45,     0,     0,     0,     0,    53,     0,     0,    61,
     0,    95,     0,     0,    54,     0,    32,   122,     0,   142,
     0,    48,    62,    82,    87,    88,    85,    86,     0,    47,
     0,    65,     0,    55,     0,    98,    56,     0,   133,   124,
   143,    89,    90,    49,    63,    57,     0,    33,   101 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{
#ifdef __cplusplus
const
#endif
char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"TOK_ERROR",	257,
	"TOK_BOOLEAN",	258,
	"TOK_SINT8",	259,
	"TOK_UINT8",	260,
	"TOK_SINT16",	261,
	"TOK_UINT16",	262,
	"TOK_SINT32",	263,
	"TOK_UINT32",	264,
	"TOK_SINT64",	265,
	"TOK_UINT64",	266,
	"TOK_REAL32",	267,
	"TOK_REAL64",	268,
	"TOK_DATETIME",	269,
	"TOK_CHAR16",	270,
	"TOK_STRING",	271,
	"TOK_OBJECT",	272,
	"TOK_BOOLEAN_VALUE",	273,
	"TOK_REF",	274,
	"TOK_SCOPE",	275,
	"TOK_CLASS",	276,
	"TOK_ASSOCIATION",	277,
	"TOK_INDICATION",	278,
	"TOK_QUALIFIER",	279,
	"TOK_PROPERTY",	280,
	"TOK_REFERENCE",	281,
	"TOK_METHOD",	282,
	"TOK_PARAMETER",	283,
	"TOK_ANY",	284,
	"TOK_FLAVOR",	285,
	"TOK_ENABLEOVERRIDE",	286,
	"TOK_DISABLEOVERRIDE",	287,
	"TOK_RESTRICTED",	288,
	"TOK_TOSUBCLASS",	289,
	"TOK_TOINSTANCE",	290,
	"TOK_TRANSLATABLE",	291,
	"TOK_INSTANCE",	292,
	"TOK_OF",	293,
	"TOK_AS",	294,
	"TOK_PRAGMA",	295,
	"TOK_SCHEMA",	296,
	"TOK_INTEGER_VALUE",	297,
	"TOK_REAL_VALUE",	298,
	"TOK_STRING_VALUE",	299,
	"TOK_CHAR_VALUE",	300,
	"TOK_IDENT",	301,
	"TOK_ALIAS_IDENTIFIER",	302,
	"TOK_NULL",	303,
	"-unknown-",	-1	/* ends search */
};

#ifdef __cplusplus
const
#endif
char * yyreds[] =
{
	"-no such reduction-",
	"mofSpecification : mofProduction",
	"mofSpecification : mofSpecification mofProduction",
	"mofSpecification : TOK_ERROR",
	"mofProduction : compilerDirective",
	"mofProduction : classDeclaration",
	"mofProduction : qualifierDeclaration",
	"mofProduction : instanceDeclaration",
	"compilerDirective : TOK_PRAGMA TOK_IDENT '(' stringValue ')'",
	"classDeclaration : TOK_CLASS identifier classBody",
	"classDeclaration : TOK_CLASS identifier ':' identifier classBody",
	"classDeclaration : qualifierExpr TOK_CLASS identifier classBody",
	"classDeclaration : qualifierExpr TOK_CLASS identifier ':' identifier classBody",
	"classBody : '{' classFeatureList '}' ';'",
	"classBody : '{' '}' ';'",
	"classFeatureList : propertyDeclaration",
	"classFeatureList : methodDeclaration",
	"classFeatureList : referenceDeclaration",
	"classFeatureList : dynamicEmbeddedInstanceDeclaration",
	"classFeatureList : classFeatureList propertyDeclaration",
	"classFeatureList : classFeatureList methodDeclaration",
	"classFeatureList : classFeatureList referenceDeclaration",
	"classFeatureList : classFeatureList dynamicEmbeddedInstanceDeclaration",
	"qualifierExpr : '[' qualifierList ']'",
	"qualifierList : qualifier",
	"qualifierList : qualifierList ',' qualifier",
	"qualifier : identifier",
	"qualifier : identifier qualifierParameter",
	"qualifier : identifier ':' qualifierFlavorList",
	"qualifier : identifier qualifierParameter ':' qualifierFlavorList",
	"qualifierParameter : '(' constantValue ')'",
	"qualifierParameter : nonAggregateArrayInitializer",
	"flavorList : flavor",
	"flavorList : flavorList ',' flavor",
	"qualifierFlavorList : flavor",
	"qualifierFlavorList : qualifierFlavorList flavor",
	"flavor : TOK_ENABLEOVERRIDE",
	"flavor : TOK_DISABLEOVERRIDE",
	"flavor : TOK_RESTRICTED",
	"flavor : TOK_TOSUBCLASS",
	"flavor : TOK_TOINSTANCE",
	"flavor : TOK_TRANSLATABLE",
	"propertyDeclaration : dataType identifier ';'",
	"propertyDeclaration : qualifierExpr dataType identifier ';'",
	"propertyDeclaration : dataType identifier subscript ';'",
	"propertyDeclaration : qualifierExpr dataType identifier subscript ';'",
	"propertyDeclaration : dataType identifier '=' initializer ';'",
	"propertyDeclaration : qualifierExpr dataType identifier '=' initializer ';'",
	"propertyDeclaration : dataType identifier subscript '=' initializer ';'",
	"propertyDeclaration : qualifierExpr dataType identifier subscript '=' initializer ';'",
	"dynamicEmbeddedInstanceDeclaration : TOK_OBJECT identifier ';'",
	"dynamicEmbeddedInstanceDeclaration : qualifierExpr TOK_OBJECT identifier ';'",
	"dynamicEmbeddedInstanceDeclaration : TOK_OBJECT identifier subscript ';'",
	"dynamicEmbeddedInstanceDeclaration : qualifierExpr TOK_OBJECT identifier subscript ';'",
	"dynamicEmbeddedInstanceDeclaration : TOK_OBJECT identifier '=' initializer ';'",
	"dynamicEmbeddedInstanceDeclaration : qualifierExpr TOK_OBJECT identifier '=' initializer ';'",
	"dynamicEmbeddedInstanceDeclaration : TOK_OBJECT identifier subscript '=' initializer ';'",
	"dynamicEmbeddedInstanceDeclaration : qualifierExpr TOK_OBJECT identifier subscript '=' initializer ';'",
	"referenceDeclaration : objectRef identifier ';'",
	"referenceDeclaration : qualifierExpr objectRef identifier ';'",
	"referenceDeclaration : objectRef identifier initializer ';'",
	"referenceDeclaration : qualifierExpr objectRef identifier initializer ';'",
	"methodDeclaration : dataType identifier '(' parameterList ')' ';'",
	"methodDeclaration : qualifierExpr dataType identifier '(' parameterList ')' ';'",
	"methodDeclaration : dataType identifier '(' ')' ';'",
	"methodDeclaration : qualifierExpr dataType identifier '(' ')' ';'",
	"dataType : TOK_BOOLEAN",
	"dataType : TOK_SINT8",
	"dataType : TOK_UINT8",
	"dataType : TOK_SINT16",
	"dataType : TOK_UINT16",
	"dataType : TOK_SINT32",
	"dataType : TOK_UINT32",
	"dataType : TOK_SINT64",
	"dataType : TOK_UINT64",
	"dataType : TOK_REAL32",
	"dataType : TOK_REAL64",
	"dataType : TOK_CHAR16",
	"dataType : TOK_DATETIME",
	"dataType : TOK_STRING",
	"objectRef : identifier TOK_REF",
	"parameterList : parameter",
	"parameterList : parameterList ',' parameter",
	"parameter : dataType identifier",
	"parameter : objectRef identifier",
	"parameter : qualifierExpr dataType identifier",
	"parameter : qualifierExpr objectRef identifier",
	"parameter : dataType identifier subscript",
	"parameter : objectRef identifier subscript",
	"parameter : qualifierExpr dataType identifier subscript",
	"parameter : qualifierExpr objectRef identifier subscript",
	"subscript : '[' TOK_INTEGER_VALUE ']'",
	"subscript : '[' ']'",
	"initializer : scalarInitializer",
	"initializer : arrayInitializer",
	"arrayInitializer : '{' arrayInitializerList '}'",
	"arrayInitializer : '{' '}'",
	"arrayInitializerList : scalarInitializer",
	"arrayInitializerList : arrayInitializerList ',' scalarInitializer",
	"scalarInitializer : constantValue",
	"scalarInitializer : TOK_ALIAS_IDENTIFIER",
	"scalarInitializer : TOK_INSTANCE TOK_OF identifier '{' valueInitializerList '}'",
	"nonAggregateInitializer : constantValue",
	"nonAggregateInitializer : nonAggregateArrayInitializer",
	"nonAggregateArrayInitializer : '{' nonAggregateArrayInitializerList '}'",
	"nonAggregateArrayInitializer : '{' '}'",
	"nonAggregateArrayInitializerList : constantValue",
	"nonAggregateArrayInitializerList : nonAggregateArrayInitializerList ',' constantValue",
	"constantValue : TOK_INTEGER_VALUE",
	"constantValue : TOK_REAL_VALUE",
	"constantValue : TOK_CHAR_VALUE",
	"constantValue : stringValue",
	"constantValue : TOK_BOOLEAN_VALUE",
	"constantValue : TOK_NULL",
	"stringValue : TOK_STRING_VALUE",
	"stringValue : stringValue TOK_STRING_VALUE",
	"qualifierDeclaration : TOK_QUALIFIER identifier qualifierType scopeExpr ';'",
	"qualifierDeclaration : TOK_QUALIFIER identifier qualifierType scopeExpr flavorExpr ';'",
	"qualifierType : ':' dataType",
	"qualifierType : ':' dataType '=' nonAggregateInitializer",
	"qualifierType : ':' dataType subscript",
	"qualifierType : ':' dataType subscript '=' nonAggregateInitializer",
	"scopeExpr : ',' TOK_SCOPE '(' scopeList ')'",
	"scopeList : scope",
	"scopeList : scopeList ',' scope",
	"scope : TOK_CLASS",
	"scope : TOK_ASSOCIATION",
	"scope : TOK_INDICATION",
	"scope : TOK_PROPERTY",
	"scope : TOK_REFERENCE",
	"scope : TOK_METHOD",
	"scope : TOK_PARAMETER",
	"scope : TOK_ANY",
	"flavorExpr : ',' TOK_FLAVOR '(' flavorList ')'",
	"instanceDeclaration : TOK_INSTANCE TOK_OF identifier instanceBody",
	"instanceDeclaration : qualifierExpr TOK_INSTANCE TOK_OF identifier instanceBody",
	"instanceDeclaration : TOK_INSTANCE TOK_OF identifier alias instanceBody",
	"instanceDeclaration : qualifierExpr TOK_INSTANCE TOK_OF identifier alias instanceBody",
	"instanceBody : '{' valueInitializerList '}' ';'",
	"alias : TOK_AS TOK_ALIAS_IDENTIFIER",
	"valueInitializerList : valueInitializer",
	"valueInitializerList : valueInitializerList valueInitializer",
	"valueInitializer : identifier '=' initializer ';'",
	"valueInitializer : qualifierExpr identifier '=' initializer ';'",
	"identifier : TOK_IDENT",
	"identifier : TOK_CLASS",
	"identifier : TOK_OF",
	"identifier : TOK_ANY",
	"identifier : TOK_ASSOCIATION",
	"identifier : TOK_INDICATION",
	"identifier : TOK_REFERENCE",
	"identifier : TOK_PROPERTY",
	"identifier : TOK_QUALIFIER",
	"identifier : TOK_TOSUBCLASS",
	"identifier : TOK_TOINSTANCE",
	"identifier : TOK_TRANSLATABLE",
	"identifier : TOK_FLAVOR",
	"identifier : TOK_BOOLEAN",
	"identifier : TOK_DATETIME",
	"identifier : TOK_STRING",
	"identifier : TOK_PRAGMA",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long yyps_index = (yy_ps - yys);
			long yypv_index = (yy_pv - yyv);
			long yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register YYCONST int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 165 "mof.y"
{
    } break;
case 2:
# line 168 "mof.y"
{ 
    } break;
case 3:
# line 171 "mof.y"
{
        YYABORT;
    } break;
case 4:
# line 177 "mof.y"
{
    } break;
case 5:
# line 180 "mof.y"
{
        /* [TODO: validate the class here] */
        yypvt[-0].classDeclaration->flags = MI_FLAG_CLASS;
        yypvt[-0].classDeclaration->flags |= GetQualFlags(yypvt[-0].classDeclaration->qualifiers, yypvt[-0].classDeclaration->numQualifiers);
        if (FinalizeClass(yypvt[-0].classDeclaration) != 0)
            YYABORT;
            
        AddClassDecl(yypvt[-0].classDeclaration);

        if (state.classDeclCallback)
            (*state.classDeclCallback)(yypvt[-0].classDeclaration, state.classDeclCallbackData);
    } break;
case 6:
# line 193 "mof.y"
{
        AddQualifierDeclaration(yypvt[-0].qualifierDeclaration);

        if (state.qualifierDeclCallback)
            (*state.qualifierDeclCallback)(yypvt[-0].qualifierDeclaration, state.qualifierDeclCallbackData);
    } break;
case 7:
# line 200 "mof.y"
{
        if (FinalizeInstance(yypvt[-0].instanceDeclaration) != 0)
            YYABORT;

        AddInstanceDecl(yypvt[-0].instanceDeclaration);

        if (state.instanceDeclCallback)
            (*state.instanceDeclCallback)(yypvt[-0].instanceDeclaration, state.instanceDeclCallbackData);
    } break;
case 8:
# line 212 "mof.y"
{
        if (strcmp(yypvt[-3].string, "include") == 0)
        {
            if (openIncludeFile(yypvt[-1].string) != 0)
                YYABORT;
        }
        else if (strcmp(yypvt[-3].string, "instancelocale") == 0)
        {
            if (state.pragmaCallback)
                (*state.pragmaCallback)(yypvt[-3].string, yypvt[-1].string, state.pragmaCallbackData);
        }
        else if (strcmp(yypvt[-3].string, "locale") == 0)
        {
            if (state.pragmaCallback)
                (*state.pragmaCallback)(yypvt[-3].string, yypvt[-1].string, state.pragmaCallbackData);
        }
        else if (strcmp(yypvt[-3].string, "namespace") == 0)
        {
            if (state.pragmaCallback)
                (*state.pragmaCallback)(yypvt[-3].string, yypvt[-1].string, state.pragmaCallbackData);
        }
        else
        {
            yywarnf(ID_UNKNOWN_PRAGMA, 
                "warning: unknown pragma: %s=%s", yypvt[-3].string, yypvt[-1].string);

            if (state.pragmaCallback)
                (*state.pragmaCallback)(yypvt[-3].string, yypvt[-1].string, state.pragmaCallbackData);
        }
    } break;
case 9:
# line 245 "mof.y"
{
        /* Check whether class already exists */
        if (FindClassDecl(yypvt[-1].string))
        {
            yyerrorf(ID_CLASS_ALREADY_DEFINED, 
                "class already defined: \"%s\"", yypvt[-1].string);
            YYABORT;
        }

        yyval.classDeclaration = CALLOC_T(MI_ClassDecl, 1);
        yyval.classDeclaration->flags = MI_FLAG_CLASS;
        yyval.classDeclaration->name = yypvt[-1].string;
        yyval.classDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.classDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
        yyval.classDeclaration->methods = yypvt[-0].featureList.methodList.data;
        yyval.classDeclaration->numMethods = yypvt[-0].featureList.methodList.size;
    } break;
case 10:
# line 263 "mof.y"
{
        const MI_ClassDecl* scd;

        /* Check whether class already exists */
        if (FindClassDecl(yypvt[-3].string))
        {
            yyerrorf(ID_CLASS_ALREADY_DEFINED, 
                "class already defined: \"%s\"", yypvt[-3].string);
            YYABORT;
        }
 
        /* Check whether superclass exists */
        scd = FindClassDecl(yypvt[-1].string);

        if (!scd)
        {
            yyerrorf(ID_UNDEFINED_SUPERCLASS, 
                "super class of \"%s\" is undefined: \"%s\"", yypvt[-3].string, yypvt[-1].string);
            YYABORT;
        }

        yyval.classDeclaration = CALLOC_T(MI_ClassDecl, 1);
        yyval.classDeclaration->flags = MI_FLAG_CLASS;
        yyval.classDeclaration->name = yypvt[-3].string;
        yyval.classDeclaration->superClass = yypvt[-1].string;
        yyval.classDeclaration->superClassDecl = (MI_ClassDecl*)scd;
        yyval.classDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.classDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
        yyval.classDeclaration->methods = yypvt[-0].featureList.methodList.data;
        yyval.classDeclaration->numMethods = yypvt[-0].featureList.methodList.size;
    } break;
case 11:
# line 295 "mof.y"
{
        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_CLASS, &yypvt[-3].qualifierList) != 0)
            YYABORT;

        /* Check whether class already exists */
        if (FindClassDecl(yypvt[-1].string))
        {
            yyerrorf(ID_CLASS_ALREADY_DEFINED, 
                "class already defined: \"%s\"", yypvt[-1].string);
            YYABORT;
        }

        yyval.classDeclaration = CALLOC_T(MI_ClassDecl, 1);
        yyval.classDeclaration->flags = MI_FLAG_CLASS;
        yyval.classDeclaration->name = yypvt[-1].string;
        yyval.classDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.classDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
        yyval.classDeclaration->methods = yypvt[-0].featureList.methodList.data;
        yyval.classDeclaration->numMethods = yypvt[-0].featureList.methodList.size;
        yyval.classDeclaration->qualifiers = yypvt[-3].qualifierList.data;
        yyval.classDeclaration->numQualifiers = yypvt[-3].qualifierList.size;
    } break;
case 12:
# line 319 "mof.y"
{
        const MI_ClassDecl* scd;

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_CLASS, &yypvt[-5].qualifierList) != 0)
            YYABORT;

        /* Check whether class already exists */
        if (FindClassDecl(yypvt[-3].string))
        {
            yyerrorf(ID_CLASS_ALREADY_DEFINED, 
                "class already defined: \"%s\"", yypvt[-3].string);
            YYABORT;
        }

        /* Check whether superclass exists */
        scd = FindClassDecl(yypvt[-1].string);

        if (!scd)
        {
            yyerrorf(ID_UNDEFINED_SUPERCLASS, 
                "super class of \"%s\" is undefined: \"%s\"", yypvt[-3].string, yypvt[-1].string);
            YYABORT;
        }

        yyval.classDeclaration = CALLOC_T(MI_ClassDecl, 1);
        yyval.classDeclaration->flags = MI_FLAG_CLASS;
        yyval.classDeclaration->name = yypvt[-3].string;
        yyval.classDeclaration->superClass = scd->name;
        yyval.classDeclaration->superClassDecl = (MI_ClassDecl*)scd;
        yyval.classDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.classDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
        yyval.classDeclaration->methods = yypvt[-0].featureList.methodList.data;
        yyval.classDeclaration->numMethods = yypvt[-0].featureList.methodList.size;
        yyval.classDeclaration->qualifiers = yypvt[-5].qualifierList.data;
        yyval.classDeclaration->numQualifiers = yypvt[-5].qualifierList.size;
    } break;
case 13:
# line 359 "mof.y"
{
        yyval.featureList = yypvt[-2].featureList;
    } break;
case 14:
# line 363 "mof.y"
{
        yyval.featureList.propertySet.data = NULL;
        yyval.featureList.propertySet.size = 0;
        yyval.featureList.methodList.data = NULL;
        yyval.featureList.methodList.size = 0;
    } break;
case 15:
# line 372 "mof.y"
{
        if (CheckPropertyValueConstraints(yypvt[-0].property) != 0)
        {
            YYABORT;
        }
        yyval.featureList.propertySet.data = NULL;
        yyval.featureList.propertySet.size = 0;
        yyval.featureList.methodList.data = NULL;
        yyval.featureList.methodList.size = 0;
        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 16:
# line 386 "mof.y"
{
        yyval.featureList.propertySet.data = NULL;
        yyval.featureList.propertySet.size = 0;
        yyval.featureList.methodList.data = NULL;
        yyval.featureList.methodList.size = 0;
        yypvt[-0].methodDecl->flags = MI_FLAG_METHOD;
        yypvt[-0].methodDecl->flags |= GetQualFlags(yypvt[-0].methodDecl->qualifiers, yypvt[-0].methodDecl->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.methodList, yypvt[-0].methodDecl);
    } break;
case 17:
# line 396 "mof.y"
{
        yyval.featureList.propertySet.data = NULL;
        yyval.featureList.propertySet.size = 0;
        yyval.featureList.methodList.data = NULL;
        yyval.featureList.methodList.size = 0;
        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 18:
# line 406 "mof.y"
{
        yyval.featureList.propertySet.data = NULL;
        yyval.featureList.propertySet.size = 0;
        yyval.featureList.methodList.data = NULL;
        yyval.featureList.methodList.size = 0;
        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 19:
# line 416 "mof.y"
{
        if (CheckPropertyValueConstraints(yypvt[-0].property) != 0)
        {
            YYABORT;
        }

        if (FindProperty(&yypvt[-1].featureList.propertySet, yypvt[-0].property->name))
        {
            yyerrorf(ID_CLASS_FEATURE_ALREADY_DEFINED, 
                "class feature already defined: \"%s\"", yypvt[-0].property->name);
            YYABORT;
        }

        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 20:
# line 434 "mof.y"
{
        if (FindMethod(&yypvt[-1].featureList.methodList, yypvt[-0].methodDecl->name))
        {
            yyerrorf(ID_CLASS_FEATURE_ALREADY_DEFINED, 
                "class feature already defined: \"%s\"", yypvt[-0].methodDecl->name);
            YYABORT;
        }

        yypvt[-0].methodDecl->flags = MI_FLAG_METHOD;
        yypvt[-0].methodDecl->flags |= GetQualFlags(yypvt[-0].methodDecl->qualifiers, yypvt[-0].methodDecl->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.methodList, yypvt[-0].methodDecl);
    } break;
case 21:
# line 447 "mof.y"
{
        if (FindProperty(&yypvt[-1].featureList.propertySet, yypvt[-0].property->name))
        {
            yyerrorf(ID_CLASS_FEATURE_ALREADY_DEFINED, 
                "class feature already defined: \"%s\"", yypvt[-0].property->name);
            YYABORT;
        }

        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 22:
# line 460 "mof.y"
{
        if (FindProperty(&yypvt[-1].featureList.propertySet, yypvt[-0].property->name))
        {
            yyerrorf(ID_CLASS_FEATURE_ALREADY_DEFINED,
                "class feature already defined: \"%s\"", yypvt[-0].property->name);
            YYABORT;
        }

        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 23:
# line 475 "mof.y"
{
        yyval.qualifierList = yypvt[-1].qualifierList;
    } break;
case 24:
# line 481 "mof.y"
{
        yyval.qualifierList.data = NULL;
        yyval.qualifierList.size = 0;
        PtrArray_Append((PtrArray*)&yyval.qualifierList, yypvt[-0].qualifier);
    } break;
case 25:
# line 487 "mof.y"
{
        if (FindQualifier(&yypvt[-2].qualifierList, yypvt[-0].qualifier->name))
        {
            yyerrorf(ID_DUPLICATE_QUALIFIER, 
                "duplicate qualifier: \"%s\"", yypvt[-0].qualifier->name);
            YYABORT;
        }

        PtrArray_Append((PtrArray*)&yyval.qualifierList, yypvt[-0].qualifier);
    } break;
case 26:
# line 500 "mof.y"
{
        MI_Qualifier* q;
        const MI_QualifierDecl* qd;

        qd = FindQualifierDeclaration(yypvt[-0].string);

        if (!qd)
        {
            yyerrorf(ID_UNDEFINED_QUALIFIER, "undefined qualifier: \"%s\"", yypvt[-0].string);
            YYABORT;
        }

        if (qd->type != MI_BOOLEAN)
        {
            yyerrorf(ID_MISSING_QUALIFIER_INITIALIZER, 
                "qualifier is missing initializer: \"%s\"", yypvt[-0].string);
            YYABORT;
        }
        
        
        q = CALLOC_T(MI_Qualifier, 1);
        q->name = qd->name; /* use casing of qualifier declaration name */
        q->type = qd->type;
        q->flavor = qd->flavor;
        q->value = NewTrueValue();
        yyval.qualifier = q;
    } break;
case 27:
# line 528 "mof.y"
{
        MI_Qualifier* q;
        const MI_QualifierDecl* qd;
        void* value;

        qd = FindQualifierDeclaration(yypvt[-1].string);

        if (!qd)
        {
            yyerrorf(ID_UNDEFINED_QUALIFIER, "undefined qualifier: \"%s\"", yypvt[-1].string);
            YYABORT;
        }

        if (InitializerToValue(&yypvt[-0].initializer, qd->type, &value) != 0)
        {
            yyerrorf(ID_INVALID_QUALIFIER_INITIALIZER, 
                "invalid initializer for qualifer: \"%s\"", yypvt[-1].string);
            YYABORT;
        }
        
        q = CALLOC_T(MI_Qualifier, 1);
        q->name = qd->name; /* use casing of qualifier declaration name */
        q->type = qd->type;
        q->flavor = qd->flavor;
        q->value = value;
        yyval.qualifier = q;
    } break;
case 28:
# line 556 "mof.y"
{
        MI_Qualifier* q;
        const MI_QualifierDecl* qd;

        qd = FindQualifierDeclaration(yypvt[-2].string);

        if (!qd)
        {
            yyerrorf(ID_UNDEFINED_QUALIFIER, "undefined qualifier: \"%s\"", yypvt[-2].string);
            YYABORT;
        }

        if (qd->type != MI_BOOLEAN)
        {
            yyerrorf(ID_MISSING_QUALIFIER_INITIALIZER, 
                "qualifier is missing initializer: \"%s\"", yypvt[-2].string);
            YYABORT;
        }
        
        q = CALLOC_T(MI_Qualifier, 1);
        q->name = qd->name; /* use casing of qualifier declaration name */
        q->type = qd->type;
        q->flavor = PropagateFlavors(yypvt[-0].flags, qd->flavor);
        q->value = NewTrueValue();
        yyval.qualifier = q;
    } break;
case 29:
# line 583 "mof.y"
{
        MI_Qualifier* q;
        const MI_QualifierDecl* qd;
        void* value;

        qd = FindQualifierDeclaration(yypvt[-3].string);

        if (!qd)
        {
            yyerrorf(ID_UNDEFINED_QUALIFIER, "undefined qualifier: \"%s\"", yypvt[-3].string);
            YYABORT;
        }

        if (InitializerToValue(&yypvt[-2].initializer, qd->type, &value) != 0)
        {
            yyerrorf(ID_INVALID_QUALIFIER_INITIALIZER, 
                "invalid initializer for qualifer: \"%s\"", yypvt[-3].string);
            YYABORT;
        }
        
        q = CALLOC_T(MI_Qualifier, 1);
        q->name = qd->name; /* use casing of qualifier declaration name */
        q->type = qd->type;
        q->value = value;
        q->flavor = PropagateFlavors(yypvt[-0].flags, qd->flavor);
        yyval.qualifier = q;
    } break;
case 30:
# line 613 "mof.y"
{
        memset(&yyval.initializer, 0, sizeof(yyval.initializer));
        yyval.initializer.data = CALLOC_T(MOF_ConstantValue, 1);
        yyval.initializer.data[0] = yypvt[-1].constantValue;
        yyval.initializer.size = 1;
    } break;
case 31:
# line 620 "mof.y"
{
        yyval.initializer = yypvt[-0].initializer;
    } break;
case 32:
# line 626 "mof.y"
{
        yyval.flags = yypvt[-0].flags;
    } break;
case 33:
# line 630 "mof.y"
{
        yyval.flags |= yypvt[-0].flags;
    } break;
case 34:
# line 636 "mof.y"
{
        yyval.flags = yypvt[-0].flags;
    } break;
case 35:
# line 640 "mof.y"
{
        yyval.flags |= yypvt[-0].flags;
    } break;
case 36:
# line 646 "mof.y"
{
        yyval.flags = MI_FLAG_ENABLEOVERRIDE;
    } break;
case 37:
# line 650 "mof.y"
{
        yyval.flags = MI_FLAG_DISABLEOVERRIDE;
    } break;
case 38:
# line 654 "mof.y"
{
        yyval.flags = MI_FLAG_RESTRICTED;
    } break;
case 39:
# line 658 "mof.y"
{
        yyval.flags = MI_FLAG_TOSUBCLASS;
    } break;
case 40:
# line 662 "mof.y"
{
        yyval.flags = MI_FLAG_TOINSTANCE;
        if (state.extensionsEnabled == MI_FALSE)
        {
            yyerrorf(ID_UNSUPPORTED, "Unsupported flavor: ToInstance");
            YYABORT;
        }
    } break;
case 41:
# line 671 "mof.y"
{
        yyval.flags = MI_FLAG_TRANSLATABLE;
    } break;
case 42:
# line 677 "mof.y"
{
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-1].string;
        yyval.property->type = yypvt[-2].type;
    } break;
case 43:
# line 683 "mof.y"
{
        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PROPERTY, &yypvt[-3].qualifierList) != 0)
            YYABORT;

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-1].string;
        yyval.property->type = yypvt[-2].type;
        yyval.property->qualifiers = yypvt[-3].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-3].qualifierList.size;
    } break;
case 44:
# line 695 "mof.y"
{
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-2].string;
        yyval.property->type = ARRAYOF(yypvt[-3].type);
        yyval.property->subscript = (MI_Uint32)yypvt[-1].integer;
    } break;
case 45:
# line 702 "mof.y"
{
        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PROPERTY, &yypvt[-4].qualifierList) != 0)
            YYABORT;

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-2].string;
        yyval.property->type = ARRAYOF(yypvt[-3].type);
        yyval.property->qualifiers = yypvt[-4].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-4].qualifierList.size;
        yyval.property->subscript = (MI_Uint32)yypvt[-1].integer;
    } break;
case 46:
# line 715 "mof.y"
{
        void* value;

        if (InitializerToValue(&yypvt[-1].initializer, yypvt[-4].type, &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-3].string;
        yyval.property->type = yypvt[-4].type;
        yyval.property->value = value;
    } break;
case 47:
# line 730 "mof.y"
{
        void* value;

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PROPERTY, &yypvt[-5].qualifierList) != 0)
            YYABORT;

        if (InitializerToValue(&yypvt[-1].initializer, yypvt[-4].type, &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-3].string;
        yyval.property->type = yypvt[-4].type;
        yyval.property->qualifiers = yypvt[-5].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-5].qualifierList.size;
        yyval.property->value = value;
    } break;
case 48:
# line 751 "mof.y"
{
        void* value;

        if (InitializerToValue(&yypvt[-1].initializer, ARRAYOF(yypvt[-5].type), &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-4].string;
        yyval.property->type = ARRAYOF(yypvt[-5].type);
        yyval.property->subscript = (MI_Uint32)yypvt[-3].integer;
        yyval.property->value = value;
    } break;
case 49:
# line 767 "mof.y"
{
        void* value;

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PROPERTY, &yypvt[-6].qualifierList) != 0)
            YYABORT;

        if (InitializerToValue(&yypvt[-1].initializer, ARRAYOF(yypvt[-5].type), &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-4].string;
        yyval.property->type = ARRAYOF(yypvt[-5].type);
        yyval.property->qualifiers = yypvt[-6].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-6].qualifierList.size;
        yyval.property->subscript = (MI_Uint32)yypvt[-3].integer;
        yyval.property->value = value;
    } break;
case 50:
# line 791 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCE;
        yyval.property->name = yypvt[-1].string;
        yyval.property->className = "?";
    } break;
case 51:
# line 800 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCE;
        yyval.property->name = yypvt[-1].string;
        yyval.property->className = "?";
        yyval.property->qualifiers = yypvt[-3].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-3].qualifierList.size;
    } break;
case 52:
# line 811 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCEA;
        yyval.property->name = yypvt[-2].string;
        yyval.property->className = "?";
        yyval.property->subscript = 0;
    } break;
case 53:
# line 821 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCEA;
        yyval.property->name = yypvt[-2].string;
        yyval.property->className = "?";
        yyval.property->subscript = 0;
        yyval.property->qualifiers = yypvt[-4].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-4].qualifierList.size;
    } break;
case 54:
# line 833 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCE;
        yyval.property->name = yypvt[-3].string;
        yyval.property->className = "?";
        yywarnf(ID_IGNORED_INITIALIZER, "warning: ignored initializer");
        /* TODO: use initializer */
    } break;
case 55:
# line 844 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCE;
        yyval.property->name = yypvt[-3].string;
        yyval.property->className = "?";
        yyval.property->qualifiers = yypvt[-5].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-5].qualifierList.size;
        yywarnf(ID_IGNORED_INITIALIZER, "warning: ignored initializer");
        /* TODO: use initializer */
    } break;
case 56:
# line 857 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCEA;
        yyval.property->name = yypvt[-4].string;
        yyval.property->className = "?";
        yyval.property->subscript = (MI_Uint32)yypvt[-3].integer;
        yywarnf(ID_IGNORED_INITIALIZER, "warning: ignored initializer");
        /* TODO: use initializer */
    } break;
case 57:
# line 869 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: OBJECT keyword is not supported");
        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_INSTANCEA;
        yyval.property->name = yypvt[-4].string;
        yyval.property->className = "?";
        yyval.property->subscript = (MI_Uint32)yypvt[-3].integer;
        yyval.property->qualifiers = yypvt[-6].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-6].qualifierList.size;
        yywarnf(ID_IGNORED_INITIALIZER, "warning: ignored initializer");
        /* TODO: use initializer */
    } break;
case 58:
# line 885 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-2].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-2].string);
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_REFERENCE;
        yyval.property->name = yypvt[-1].string;
        yyval.property->className = cd->name;
    } break;
case 59:
# line 902 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-2].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-2].string);
            YYABORT;
        }

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_REFERENCE, &yypvt[-3].qualifierList) != 0)
            YYABORT;

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_REFERENCE;
        yyval.property->name = yypvt[-1].string;
        yyval.property->className = cd->name;
        yyval.property->qualifiers = yypvt[-3].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-3].qualifierList.size;
    } break;
case 60:
# line 925 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-3].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-3].string);
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_REFERENCE;
        yyval.property->name = yypvt[-2].string;
        yyval.property->className = cd->name;
        yywarnf(ID_IGNORED_INITIALIZER, "warning: ignored initializer");
        /* [TODO: use initializer */
    } break;
case 61:
# line 944 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-3].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-3].string);
            YYABORT;
        }

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_REFERENCE, &yypvt[-4].qualifierList) != 0)
            YYABORT;

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->type = MI_REFERENCE;
        yyval.property->name = yypvt[-2].string;
        yyval.property->className = cd->name;
        yyval.property->qualifiers = yypvt[-4].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-4].qualifierList.size;
        yywarnf(ID_IGNORED_INITIALIZER, "warning: ignored initializer");
        /* [TODO: use initializer */
    } break;
case 62:
# line 971 "mof.y"
{
        yyval.methodDecl = CALLOC_T(MI_MethodDecl, 1);
        yyval.methodDecl->name = yypvt[-4].string;
        yyval.methodDecl->parameters = yypvt[-2].parameterList.data;
        yyval.methodDecl->numParameters = yypvt[-2].parameterList.size;
        yyval.methodDecl->returnType = yypvt[-5].type;
    } break;
case 63:
# line 979 "mof.y"
{
        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_METHOD, &yypvt[-6].qualifierList) != 0)
            YYABORT;

        yyval.methodDecl = CALLOC_T(MI_MethodDecl, 1);
        yyval.methodDecl->name = yypvt[-4].string;
        yyval.methodDecl->parameters = yypvt[-2].parameterList.data;
        yyval.methodDecl->numParameters = yypvt[-2].parameterList.size;
        yyval.methodDecl->qualifiers = yypvt[-6].qualifierList.data;
        yyval.methodDecl->numQualifiers = yypvt[-6].qualifierList.size;
        yyval.methodDecl->returnType = yypvt[-5].type;
    } break;
case 64:
# line 993 "mof.y"
{
        MOF_ParameterList parameterList = PTRARRAY_INITIALIZER;

        yyval.methodDecl = CALLOC_T(MI_MethodDecl, 1);
        yyval.methodDecl->name = yypvt[-3].string;
        yyval.methodDecl->parameters = parameterList.data;
        yyval.methodDecl->numParameters = parameterList.size;
        yyval.methodDecl->returnType = yypvt[-4].type;
    } break;
case 65:
# line 1003 "mof.y"
{
        MOF_ParameterList parameterList = PTRARRAY_INITIALIZER;

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_METHOD, &yypvt[-5].qualifierList) != 0)
            YYABORT;

        yyval.methodDecl = CALLOC_T(MI_MethodDecl, 1);
        yyval.methodDecl->name = yypvt[-3].string;
        yyval.methodDecl->parameters = parameterList.data;
        yyval.methodDecl->numParameters = parameterList.size;
        yyval.methodDecl->qualifiers = yypvt[-5].qualifierList.data;
        yyval.methodDecl->numQualifiers = yypvt[-5].qualifierList.size;
        yyval.methodDecl->returnType = yypvt[-4].type;
    } break;
case 66:
# line 1021 "mof.y"
{
        yyval.type = MI_BOOLEAN;
    } break;
case 67:
# line 1025 "mof.y"
{
        yyval.type = MI_SINT8;
    } break;
case 68:
# line 1029 "mof.y"
{
        yyval.type = MI_UINT8;
    } break;
case 69:
# line 1033 "mof.y"
{
        yyval.type = MI_SINT16;
    } break;
case 70:
# line 1037 "mof.y"
{
        yyval.type = MI_UINT16;
    } break;
case 71:
# line 1041 "mof.y"
{
        yyval.type = MI_SINT32;
    } break;
case 72:
# line 1045 "mof.y"
{
        yyval.type = MI_UINT32;
    } break;
case 73:
# line 1049 "mof.y"
{
        yyval.type = MI_SINT64;
    } break;
case 74:
# line 1053 "mof.y"
{
        yyval.type = MI_UINT64;
    } break;
case 75:
# line 1057 "mof.y"
{
        yyval.type = MI_REAL32;
    } break;
case 76:
# line 1061 "mof.y"
{
        yyval.type = MI_REAL64;
    } break;
case 77:
# line 1065 "mof.y"
{
        yyval.type = MI_CHAR16;
    } break;
case 78:
# line 1069 "mof.y"
{
        yyval.type = MI_DATETIME;
    } break;
case 79:
# line 1073 "mof.y"
{
        yyval.type = MI_STRING;
    } break;
case 80:
# line 1079 "mof.y"
{
        yyval.string = yypvt[-1].string;
    } break;
case 81:
# line 1085 "mof.y"
{
        yypvt[-0].parameter->flags = MI_FLAG_PARAMETER;
        yypvt[-0].parameter->flags |= GetQualFlags(yypvt[-0].parameter->qualifiers, yypvt[-0].parameter->numQualifiers);
        yyval.parameterList.data = NULL;
        yyval.parameterList.size = 0;
        PtrArray_Append((PtrArray*)&yyval.parameterList, yypvt[-0].parameter);
    } break;
case 82:
# line 1093 "mof.y"
{
        if (FindParameter(&yypvt[-2].parameterList, yypvt[-0].parameter->name))
        {
            yyerrorf(ID_PARAMETER_ALREADY_DEFINED, 
                "parameter already defined: \"%s\"", yypvt[-0].parameter->name);
            YYABORT;
        }

        yypvt[-0].parameter->flags = MI_FLAG_PARAMETER;
        yypvt[-0].parameter->flags |= GetQualFlags(yypvt[-0].parameter->qualifiers, yypvt[-0].parameter->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.parameterList, yypvt[-0].parameter);
    } break;
case 83:
# line 1108 "mof.y"
{
        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-0].string;
        yyval.parameter->type = yypvt[-1].type;
    } break;
case 84:
# line 1114 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-1].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-1].string);
            YYABORT;
        }

        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-0].string;
        yyval.parameter->type = MI_REFERENCE;
        yyval.parameter->className = cd->name;
    } break;
case 85:
# line 1131 "mof.y"
{
        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PARAMETER, &yypvt[-2].qualifierList) != 0)
            YYABORT;

        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-0].string;
        yyval.parameter->type = yypvt[-1].type;
        yyval.parameter->qualifiers = yypvt[-2].qualifierList.data;
        yyval.parameter->numQualifiers = yypvt[-2].qualifierList.size;
    } break;
case 86:
# line 1143 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-1].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-1].string);
            YYABORT;
        }

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PARAMETER, &yypvt[-2].qualifierList) != 0)
            YYABORT;

        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-0].string;
        yyval.parameter->type = MI_REFERENCE;
        yyval.parameter->className = cd->name;
        yyval.parameter->qualifiers = yypvt[-2].qualifierList.data;
        yyval.parameter->numQualifiers = yypvt[-2].qualifierList.size;
    } break;
case 87:
# line 1166 "mof.y"
{
        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-1].string;
        yyval.parameter->type = ARRAYOF(yypvt[-2].type);
        yyval.parameter->subscript = (MI_Uint32)yypvt[-0].integer;
    } break;
case 88:
# line 1173 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-2].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-2].string);
            YYABORT;
        }

        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-1].string;
        yyval.parameter->type = ARRAYOF(MI_REFERENCE);
        yyval.parameter->className = cd->name;
        yyval.parameter->subscript = (MI_Uint32)yypvt[-0].integer;
    } break;
case 89:
# line 1191 "mof.y"
{
        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PARAMETER, &yypvt[-3].qualifierList) != 0)
            YYABORT;

        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-1].string;
        yyval.parameter->type = ARRAYOF(yypvt[-2].type);
        yyval.parameter->subscript = (MI_Uint32)yypvt[-0].integer;
        yyval.parameter->qualifiers = yypvt[-3].qualifierList.data;
        yyval.parameter->numQualifiers = yypvt[-3].qualifierList.size;
    } break;
case 90:
# line 1204 "mof.y"
{
        const MI_ClassDecl* cd;

        /* Verify that class exists */
        cd = FindClassDecl(yypvt[-2].string);
        if (!cd)
        {
            yyerrorf(ID_UNDEFINED_CLASS, "undefined class: \"%s\"", yypvt[-2].string);
            YYABORT;
        }

        /* Check qualifier scope */
        if (CheckScope(MI_FLAG_PARAMETER, &yypvt[-3].qualifierList) != 0)
            YYABORT;

        yyval.parameter = CALLOC_T(MI_ParameterDecl, 1);
        yyval.parameter->name = yypvt[-1].string;
        yyval.parameter->type = ARRAYOF(MI_REFERENCE);
        yyval.parameter->className = cd->name;
        yyval.parameter->subscript = (MI_Uint32)yypvt[-0].integer;
        yyval.parameter->qualifiers = yypvt[-3].qualifierList.data;
        yyval.parameter->numQualifiers = yypvt[-3].qualifierList.size;
    } break;
case 91:
# line 1230 "mof.y"
{
        if (yypvt[-1].integer <= 0)
        {
            yyerrorf(ID_ILLEGAL_ARRAY_SUBSCRIPT, 
                "illegal array subscript: " SINT64_FMT, yypvt[-1].integer);
            YYABORT;
        }

        yyval.integer = yypvt[-1].integer;
    } break;
case 92:
# line 1241 "mof.y"
{
        /* 0 signifies a dynamic array */
        yyval.integer = 0;
    } break;
case 93:
# line 1248 "mof.y"
{
        yyval.initializer = yypvt[-0].initializer;
    } break;
case 94:
# line 1252 "mof.y"
{
        yyval.initializer = yypvt[-0].initializer;
    } break;
case 95:
# line 1258 "mof.y"
{
        yyval.initializer = yypvt[-1].initializer;
    } break;
case 96:
# line 1262 "mof.y"
{
        yyval.initializer.data = NULL;
        yyval.initializer.size = 0;
        yyval.initializer.isArray = 1;
    } break;
case 97:
# line 1270 "mof.y"
{
        memset(&yyval.initializer, 0, sizeof(yyval.initializer));
        yyval.initializer.data = CALLOC_T(MOF_ConstantValue, 1);
        yyval.initializer.data[0] = yypvt[-0].initializer.data[0];
        yyval.initializer.size = 1;
        yyval.initializer.isArray = 1;
    } break;
case 98:
# line 1278 "mof.y"
{
        yypvt[-2].initializer.data = REALLOC_T(MOF_ConstantValue, yypvt[-2].initializer.data, yypvt[-2].initializer.size + 1);
        yypvt[-2].initializer.data[yypvt[-2].initializer.size] = yypvt[-0].initializer.data[0];
        yypvt[-2].initializer.size++;
        yyval.initializer = yypvt[-2].initializer;
    } break;
case 99:
# line 1287 "mof.y"
{
        memset(&yyval.initializer, 0, sizeof(yyval.initializer));
        yyval.initializer.data = CALLOC_T(MOF_ConstantValue, 1);
        yyval.initializer.data[0] = yypvt[-0].constantValue;
        yyval.initializer.size = 1;
    } break;
case 100:
# line 1294 "mof.y"
{
        memset(&yyval.initializer, 0, sizeof(yyval.initializer));
        yyval.initializer.data = CALLOC_T(MOF_ConstantValue, 1);
        yyval.initializer.data[0].type = TOK_STRING_VALUE;
        yyval.initializer.data[0].value.string = yypvt[-0].string;
        yyval.initializer.size = 1;
    } break;
case 101:
# line 1302 "mof.y"
{
        if (state.extensionsEnabled == MI_FALSE)
            yywarnf(ID_UNSUPPORTED, "warning: dynamic objects are not supported");
        /* TODO: look up class $3, validate property names/types, store dynamic instance properties in this instance */
        memset(&yyval.initializer, 0, sizeof(yyval.initializer));
        yyval.initializer.data = CALLOC_T(MOF_ConstantValue, 1);
        yyval.initializer.data[0].type = TOK_STRING_VALUE;
        yyval.initializer.data[0].value.string = yypvt[-3].string;
        yyval.initializer.size = 1;
    } break;
case 102:
# line 1315 "mof.y"
{
        memset(&yyval.initializer, 0, sizeof(yyval.initializer));
        yyval.initializer.data = CALLOC_T(MOF_ConstantValue, 1);
        yyval.initializer.data[0] = yypvt[-0].constantValue;
        yyval.initializer.size = 1;
    } break;
case 103:
# line 1322 "mof.y"
{
        yyval.initializer = yypvt[-0].initializer;
    } break;
case 104:
# line 1328 "mof.y"
{
        yyval.initializer = yypvt[-1].initializer;
    } break;
case 105:
# line 1332 "mof.y"
{
        yyval.initializer.data = NULL;
        yyval.initializer.size = 0;
        yyval.initializer.isArray = MI_TRUE;
    } break;
case 106:
# line 1340 "mof.y"
{
        memset(&yyval.initializer, 0, sizeof(yyval.initializer));
        yyval.initializer.data = CALLOC_T(MOF_ConstantValue, 1);
        yyval.initializer.data[0] = yypvt[-0].constantValue;
        yyval.initializer.size = 1;
        yyval.initializer.isArray = MI_TRUE;
    } break;
case 107:
# line 1348 "mof.y"
{
        yypvt[-2].initializer.data = REALLOC_T(MOF_ConstantValue, yypvt[-2].initializer.data, yypvt[-2].initializer.size + 1);
        yypvt[-2].initializer.data[yypvt[-2].initializer.size] = yypvt[-0].constantValue;
        yypvt[-2].initializer.size++;
        yypvt[-2].initializer.isArray = MI_TRUE;
        yyval.initializer = yypvt[-2].initializer;
    } break;
case 108:
# line 1358 "mof.y"
{
        yyval.constantValue.type = TOK_INTEGER_VALUE;
        yyval.constantValue.value.integer = yypvt[-0].integer;
    } break;
case 109:
# line 1363 "mof.y"
{
        yyval.constantValue.type = TOK_REAL_VALUE;
        yyval.constantValue.value.real = yypvt[-0].real;
    } break;
case 110:
# line 1368 "mof.y"
{
        yyval.constantValue.type = TOK_CHAR_VALUE;
        yyval.constantValue.value.character = yypvt[-0].character;
    } break;
case 111:
# line 1373 "mof.y"
{
        yyval.constantValue.type = TOK_STRING_VALUE;
        yyval.constantValue.value.string = yypvt[-0].string;
    } break;
case 112:
# line 1378 "mof.y"
{
        yyval.constantValue.type = TOK_BOOLEAN_VALUE;
        yyval.constantValue.value.boolean = yypvt[-0].boolean;
    } break;
case 113:
# line 1383 "mof.y"
{
        yyval.constantValue.type = TOK_NULL;
    } break;
case 114:
# line 1389 "mof.y"
{
	yyval.string = yypvt[-0].string;
    } break;
case 115:
# line 1393 "mof.y"
{
        size_t size = strlen(yypvt[-1].string) + strlen(yypvt[-0].string) + 1;
        yyval.string = (char*)MOF_Realloc(&state.heap, yypvt[-1].string, size);
        Strcat(yyval.string, size, yypvt[-0].string);
        MOF_Free(&state.heap, yypvt[-0].string);
    } break;
case 116:
# line 1402 "mof.y"
{
        yypvt[-2].qualifierDeclaration->name = yypvt[-3].string;
        yypvt[-2].qualifierDeclaration->scope = yypvt[-1].flags;
        yypvt[-2].qualifierDeclaration->flavor = 0;
        yyval.qualifierDeclaration = yypvt[-2].qualifierDeclaration;
    } break;
case 117:
# line 1409 "mof.y"
{
        yypvt[-3].qualifierDeclaration->name = yypvt[-4].string;
        yypvt[-3].qualifierDeclaration->scope = yypvt[-2].flags;
        yypvt[-3].qualifierDeclaration->flavor = yypvt[-1].flags;
        yyval.qualifierDeclaration = yypvt[-3].qualifierDeclaration;
    } break;
case 118:
# line 1418 "mof.y"
{
        yyval.qualifierDeclaration = CALLOC_T(MI_QualifierDecl, 1);
        yyval.qualifierDeclaration->type = yypvt[-0].type;
    } break;
case 119:
# line 1423 "mof.y"
{
        void* value;

        if (InitializerToValue(&yypvt[-0].initializer, yypvt[-2].type, &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.qualifierDeclaration = CALLOC_T(MI_QualifierDecl, 1);
        yyval.qualifierDeclaration->type = yypvt[-2].type;
        yyval.qualifierDeclaration->value = value;
        ReleaseInitializer(&yypvt[-0].initializer);
    } break;
case 120:
# line 1438 "mof.y"
{
        yyval.qualifierDeclaration = CALLOC_T(MI_QualifierDecl, 1);
        yyval.qualifierDeclaration->type = ARRAYOF(yypvt[-1].type);
        yyval.qualifierDeclaration->subscript = (MI_Uint32)yypvt[-0].integer;
    } break;
case 121:
# line 1444 "mof.y"
{
        void* value = NULL;

        if (InitializerToValue(&yypvt[-0].initializer, ARRAYOF(yypvt[-3].type), &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.qualifierDeclaration = CALLOC_T(MI_QualifierDecl, 1);
        yyval.qualifierDeclaration->type = ARRAYOF(yypvt[-3].type);
        yyval.qualifierDeclaration->subscript = (MI_Uint32)yypvt[-2].integer;
        yyval.qualifierDeclaration->value = value;
        ReleaseInitializer(&yypvt[-0].initializer);
    } break;
case 122:
# line 1462 "mof.y"
{
        yyval.flags = yypvt[-1].flags;
    } break;
case 123:
# line 1468 "mof.y"
{
        yyval.flags = yypvt[-0].flags;
    } break;
case 124:
# line 1472 "mof.y"
{
        yyval.flags |= yypvt[-0].flags;
    } break;
case 125:
# line 1478 "mof.y"
{
        yyval.flags = MI_FLAG_CLASS;
    } break;
case 126:
# line 1482 "mof.y"
{
        yyval.flags = MI_FLAG_ASSOCIATION;
    } break;
case 127:
# line 1486 "mof.y"
{
        yyval.flags = MI_FLAG_INDICATION;
    } break;
case 128:
# line 1490 "mof.y"
{
        yyval.flags = MI_FLAG_PROPERTY;
    } break;
case 129:
# line 1494 "mof.y"
{
        yyval.flags = MI_FLAG_REFERENCE;
    } break;
case 130:
# line 1498 "mof.y"
{
        yyval.flags = MI_FLAG_METHOD;
    } break;
case 131:
# line 1502 "mof.y"
{
        yyval.flags = MI_FLAG_PARAMETER;
    } break;
case 132:
# line 1506 "mof.y"
{
        yyval.flags = MI_FLAG_ANY;
    } break;
case 133:
# line 1512 "mof.y"
{
        /* Reject incompatiable ToSubclass and Restricted flavors */
        if (yypvt[-1].flags & MI_FLAG_TOSUBCLASS && yypvt[-1].flags & MI_FLAG_RESTRICTED)
        {
            yyerrorf(ID_INCOMPATIBLE_FLAVORS, "incompatible flavors: %s/%s", 
                "ToSubclass", "Restricted");
            YYABORT;
        }

        /* Reject incompatiable EnableOverride and DisableOverride flavors */
        if (yypvt[-1].flags & MI_FLAG_ENABLEOVERRIDE && yypvt[-1].flags & MI_FLAG_DISABLEOVERRIDE)
        {
            yyerrorf(ID_INCOMPATIBLE_FLAVORS, "incompatible flavors: %s/%s", 
                "EnableOverride", "DisableOverride");
            YYABORT;
        }

        yyval.flags = yypvt[-1].flags;
    } break;
case 134:
# line 1534 "mof.y"
{
        yyval.instanceDeclaration = CALLOC_T(MI_InstanceDecl, 1);
        yyval.instanceDeclaration->flags = 0;
        yyval.instanceDeclaration->name = yypvt[-1].string;
        yyval.instanceDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.instanceDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
    } break;
case 135:
# line 1542 "mof.y"
{
        yyval.instanceDeclaration = CALLOC_T(MI_InstanceDecl, 1);
        yyval.instanceDeclaration->flags = 0;
        yyval.instanceDeclaration->name = yypvt[-1].string;
        yyval.instanceDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.instanceDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
        yyval.instanceDeclaration->qualifiers = yypvt[-4].qualifierList.data;
        yyval.instanceDeclaration->numQualifiers = yypvt[-4].qualifierList.size;
    } break;
case 136:
# line 1552 "mof.y"
{
        /* [TODO]: handle alias */
        yyval.instanceDeclaration = CALLOC_T(MI_InstanceDecl, 1);
        yyval.instanceDeclaration->flags = 0;
        yyval.instanceDeclaration->name = yypvt[-2].string;
        yyval.instanceDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.instanceDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
    } break;
case 137:
# line 1561 "mof.y"
{
        /* [TODO]: handle alias */
        yyval.instanceDeclaration = CALLOC_T(MI_InstanceDecl, 1);
        yyval.instanceDeclaration->flags = 0;
        yyval.instanceDeclaration->name = yypvt[-2].string;
        yyval.instanceDeclaration->properties = yypvt[-0].featureList.propertySet.data;
        yyval.instanceDeclaration->numProperties = yypvt[-0].featureList.propertySet.size;
        yyval.instanceDeclaration->qualifiers = yypvt[-5].qualifierList.data;
        yyval.instanceDeclaration->numQualifiers = yypvt[-5].qualifierList.size;
    } break;
case 138:
# line 1574 "mof.y"
{
        yyval.featureList = yypvt[-2].featureList;
    } break;
case 139:
# line 1580 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 140:
# line 1586 "mof.y"
{
        yyval.featureList.propertySet.data = NULL;
        yyval.featureList.propertySet.size = 0;
        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 141:
# line 1594 "mof.y"
{
        if (FindProperty(&yypvt[-1].featureList.propertySet, yypvt[-0].property->name))
        {
            yyerrorf(ID_CLASS_FEATURE_ALREADY_DEFINED, 
                "instance property already defined: \"%s\"", yypvt[-0].property->name);
            YYABORT;
        }

        yypvt[-0].property->flags = MI_FLAG_PROPERTY;
        yypvt[-0].property->flags |= GetQualFlags(yypvt[-0].property->qualifiers, yypvt[-0].property->numQualifiers);
        PtrArray_Append((PtrArray*)&yyval.featureList.propertySet, yypvt[-0].property);
    } break;
case 142:
# line 1609 "mof.y"
{
        void* value;
        MI_Type type = InitializerToType(&yypvt[-1].initializer);
        if (InitializerToValue(&yypvt[-1].initializer, type, &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-3].string;
        yyval.property->type = type;
        yyval.property->value = value;
    } break;
case 143:
# line 1624 "mof.y"
{
        void* value;
        MI_Type type = InitializerToType(&yypvt[-1].initializer);

        if (InitializerToValue(&yypvt[-1].initializer, type, &value) != 0)
        {
            yyerrorf(ID_INVALID_INITIALIZER, "invalid initializer");
            YYABORT;
        }

        yyval.property = CALLOC_T(MI_PropertyDecl, 1);
        yyval.property->name = yypvt[-3].string;
        yyval.property->type = type;
        yyval.property->value = value;
        yyval.property->qualifiers = yypvt[-4].qualifierList.data;
        yyval.property->numQualifiers = yypvt[-4].qualifierList.size;
    } break;
case 144:
# line 1644 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 145:
# line 1648 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 146:
# line 1652 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 147:
# line 1656 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 148:
# line 1660 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 149:
# line 1664 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 150:
# line 1668 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 151:
# line 1672 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 152:
# line 1676 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 153:
# line 1680 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 154:
# line 1684 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 155:
# line 1688 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 156:
# line 1692 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 157:
# line 1696 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 158:
# line 1700 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 159:
# line 1704 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
case 160:
# line 1708 "mof.y"
{
        yyval.string = yypvt[-0].string;
    } break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

