/*
**==============================================================================
**
** Open Management Infrastructure (OMI)
**
** Copyright (c) Microsoft Corporation
** 
** Licensed under the Apache License, Version 2.0 (the "License"); you may not 
** use this file except in compliance with the License. You may obtain a copy 
** of the License at 
**
**     http://www.apache.org/licenses/LICENSE-2.0 
**
** THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
** KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED 
** WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, 
** MERCHANTABLITY OR NON-INFRINGEMENT. 
**
** See the Apache 2 License for the specific language governing permissions 
** and limitations under the License.
**
**==============================================================================
*/


#ifndef _UTIL_h
#define _UTIL_h

#include "PS_ModuleFile.h"
#include "PS_Module.h"

#define FILECOUNT 10
#define MFILECOUNT (FILECOUNT-1)

typedef struct _PSModuleFile
{
    const char * filename;
    unsigned char *data;
    unsigned int datalength;
}PSModuleFile;

extern PS_Module psmodule;
extern PS_ModuleFile psmodulefiles[];

MI_Result ConstructModuleInstances(_In_ struct _MI_Context* context);
void DestructModuleInstances();
MI_Result ConstructModuleFileInstances(_In_ struct _MI_Context* context);
void DestructModuleFileInstances();
#endif
